diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-ipc.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-ipc.c
--- linux-2.6.14.5/ltt/ltt-facility-loader-ipc.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-ipc.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,86 @@
+/*
+ * ltt-facility-loader-ipc.c
+ *
+ * (C) Copyright  2005 - 
+ *          Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the LTT facility loader.
+ *
+ */
+
+
+#include <linux/ltt-facilities.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/config.h>
+#include "ltt-facility-loader-ipc.h"
+
+
+#ifdef CONFIG_LTT
+
+EXPORT_SYMBOL(LTT_FACILITY_SYMBOL);
+EXPORT_SYMBOL(LTT_FACILITY_CHECKSUM_SYMBOL);
+
+static const char ltt_facility_name[] = LTT_FACILITY_NAME;
+
+#define SYMBOL_STRING(sym) #sym
+
+static struct ltt_facility facility = {
+	.name = ltt_facility_name,
+	.num_events = LTT_FACILITY_NUM_EVENTS,
+	.checksum = LTT_FACILITY_CHECKSUM,
+	.symbol = SYMBOL_STRING(LTT_FACILITY_SYMBOL),
+};
+
+#ifndef MODULE
+
+/* Built-in facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-ipc init in kernel\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_builtin_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+	
+	return LTT_FACILITY_SYMBOL;
+}
+__initcall(facility_init);
+
+
+
+#else 
+
+/* Dynamic facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-ipc init dynamic\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_dynamic_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+
+	return LTT_FACILITY_SYMBOL;
+}
+
+static void __exit facility_exit(void)
+{
+	int err;
+
+	err = ltt_facility_dynamic_unregister(LTT_FACILITY_SYMBOL);
+	if(err != 0)
+		printk(KERN_ERR "LTT : Error in unregistering facility.\n");
+
+}
+
+module_init(facility_init)
+module_exit(facility_exit)
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Facility");
+
+#endif //MODULE
+
+#endif //CONFIG_LTT
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-ipc.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-ipc.h
--- linux-2.6.14.5/ltt/ltt-facility-loader-ipc.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-ipc.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+#ifndef _LTT_FACILITY_LOADER_IPC_H_
+#define _LTT_FACILITY_LOADER_IPC_H_
+
+#ifdef CONFIG_LTT
+
+#include <linux/ltt-facilities.h>
+#include <linux/ltt/ltt-facility-id-ipc.h>
+
+ltt_facility_t	ltt_facility_ipc;
+ltt_facility_t	ltt_facility_ipc_14120A9A;
+
+#define LTT_FACILITY_SYMBOL							ltt_facility_ipc
+#define LTT_FACILITY_CHECKSUM_SYMBOL		ltt_facility_ipc_14120A9A
+#define LTT_FACILITY_CHECKSUM						0x14120A9A
+#define LTT_FACILITY_NAME								"ipc"
+#define LTT_FACILITY_NUM_EVENTS					facility_ipc_num_events
+
+#endif //CONFIG_LTT
+
+#endif //_LTT_FACILITY_LOADER_IPC_H_
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-kernel.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-kernel.c
--- linux-2.6.14.5/ltt/ltt-facility-loader-kernel.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-kernel.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,86 @@
+/*
+ * ltt-facility-loader-kernel.c
+ *
+ * (C) Copyright  2005 - 
+ *          Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the LTT facility loader.
+ *
+ */
+
+
+#include <linux/ltt-facilities.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/config.h>
+#include "ltt-facility-loader-kernel.h"
+
+
+#ifdef CONFIG_LTT
+
+EXPORT_SYMBOL(LTT_FACILITY_SYMBOL);
+EXPORT_SYMBOL(LTT_FACILITY_CHECKSUM_SYMBOL);
+
+static const char ltt_facility_name[] = LTT_FACILITY_NAME;
+
+#define SYMBOL_STRING(sym) #sym
+
+static struct ltt_facility facility = {
+	.name = ltt_facility_name,
+	.num_events = LTT_FACILITY_NUM_EVENTS,
+	.checksum = LTT_FACILITY_CHECKSUM,
+	.symbol = SYMBOL_STRING(LTT_FACILITY_SYMBOL),
+};
+
+#ifndef MODULE
+
+/* Built-in facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-kernel init in kernel\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_builtin_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+	
+	return LTT_FACILITY_SYMBOL;
+}
+__initcall(facility_init);
+
+
+
+#else 
+
+/* Dynamic facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-kernel init dynamic\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_dynamic_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+
+	return LTT_FACILITY_SYMBOL;
+}
+
+static void __exit facility_exit(void)
+{
+	int err;
+
+	err = ltt_facility_dynamic_unregister(LTT_FACILITY_SYMBOL);
+	if(err != 0)
+		printk(KERN_ERR "LTT : Error in unregistering facility.\n");
+
+}
+
+module_init(facility_init)
+module_exit(facility_exit)
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Facility");
+
+#endif //MODULE
+
+#endif //CONFIG_LTT
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-kernel.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-kernel.h
--- linux-2.6.14.5/ltt/ltt-facility-loader-kernel.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-kernel.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+#ifndef _LTT_FACILITY_LOADER_KERNEL_H_
+#define _LTT_FACILITY_LOADER_KERNEL_H_
+
+#ifdef CONFIG_LTT
+
+#include <linux/ltt-facilities.h>
+#include <linux/ltt/ltt-facility-id-kernel.h>
+
+ltt_facility_t	ltt_facility_kernel;
+ltt_facility_t	ltt_facility_kernel_E78275BF;
+
+#define LTT_FACILITY_SYMBOL							ltt_facility_kernel
+#define LTT_FACILITY_CHECKSUM_SYMBOL		ltt_facility_kernel_E78275BF
+#define LTT_FACILITY_CHECKSUM						0xE78275BF
+#define LTT_FACILITY_NAME								"kernel"
+#define LTT_FACILITY_NUM_EVENTS					facility_kernel_num_events
+
+#endif //CONFIG_LTT
+
+#endif //_LTT_FACILITY_LOADER_KERNEL_H_
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-memory.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-memory.c
--- linux-2.6.14.5/ltt/ltt-facility-loader-memory.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-memory.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,86 @@
+/*
+ * ltt-facility-loader-memory.c
+ *
+ * (C) Copyright  2005 - 
+ *          Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the LTT facility loader.
+ *
+ */
+
+
+#include <linux/ltt-facilities.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/config.h>
+#include "ltt-facility-loader-memory.h"
+
+
+#ifdef CONFIG_LTT
+
+EXPORT_SYMBOL(LTT_FACILITY_SYMBOL);
+EXPORT_SYMBOL(LTT_FACILITY_CHECKSUM_SYMBOL);
+
+static const char ltt_facility_name[] = LTT_FACILITY_NAME;
+
+#define SYMBOL_STRING(sym) #sym
+
+static struct ltt_facility facility = {
+	.name = ltt_facility_name,
+	.num_events = LTT_FACILITY_NUM_EVENTS,
+	.checksum = LTT_FACILITY_CHECKSUM,
+	.symbol = SYMBOL_STRING(LTT_FACILITY_SYMBOL),
+};
+
+#ifndef MODULE
+
+/* Built-in facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-memory init in kernel\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_builtin_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+	
+	return LTT_FACILITY_SYMBOL;
+}
+__initcall(facility_init);
+
+
+
+#else 
+
+/* Dynamic facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-memory init dynamic\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_dynamic_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+
+	return LTT_FACILITY_SYMBOL;
+}
+
+static void __exit facility_exit(void)
+{
+	int err;
+
+	err = ltt_facility_dynamic_unregister(LTT_FACILITY_SYMBOL);
+	if(err != 0)
+		printk(KERN_ERR "LTT : Error in unregistering facility.\n");
+
+}
+
+module_init(facility_init)
+module_exit(facility_exit)
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Facility");
+
+#endif //MODULE
+
+#endif //CONFIG_LTT
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-memory.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-memory.h
--- linux-2.6.14.5/ltt/ltt-facility-loader-memory.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-memory.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+#ifndef _LTT_FACILITY_LOADER_MEMORY_H_
+#define _LTT_FACILITY_LOADER_MEMORY_H_
+
+#ifdef CONFIG_LTT
+
+#include <linux/ltt-facilities.h>
+#include <linux/ltt/ltt-facility-id-memory.h>
+
+ltt_facility_t	ltt_facility_memory;
+ltt_facility_t	ltt_facility_memory_D63D41C7;
+
+#define LTT_FACILITY_SYMBOL							ltt_facility_memory
+#define LTT_FACILITY_CHECKSUM_SYMBOL		ltt_facility_memory_D63D41C7
+#define LTT_FACILITY_CHECKSUM						0xD63D41C7
+#define LTT_FACILITY_NAME								"memory"
+#define LTT_FACILITY_NUM_EVENTS					facility_memory_num_events
+
+#endif //CONFIG_LTT
+
+#endif //_LTT_FACILITY_LOADER_MEMORY_H_
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-network.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-network.c
--- linux-2.6.14.5/ltt/ltt-facility-loader-network.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-network.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,86 @@
+/*
+ * ltt-facility-loader-network.c
+ *
+ * (C) Copyright  2005 - 
+ *          Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the LTT facility loader.
+ *
+ */
+
+
+#include <linux/ltt-facilities.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/config.h>
+#include "ltt-facility-loader-network.h"
+
+
+#ifdef CONFIG_LTT
+
+EXPORT_SYMBOL(LTT_FACILITY_SYMBOL);
+EXPORT_SYMBOL(LTT_FACILITY_CHECKSUM_SYMBOL);
+
+static const char ltt_facility_name[] = LTT_FACILITY_NAME;
+
+#define SYMBOL_STRING(sym) #sym
+
+static struct ltt_facility facility = {
+	.name = ltt_facility_name,
+	.num_events = LTT_FACILITY_NUM_EVENTS,
+	.checksum = LTT_FACILITY_CHECKSUM,
+	.symbol = SYMBOL_STRING(LTT_FACILITY_SYMBOL),
+};
+
+#ifndef MODULE
+
+/* Built-in facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-network init in kernel\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_builtin_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+	
+	return LTT_FACILITY_SYMBOL;
+}
+__initcall(facility_init);
+
+
+
+#else 
+
+/* Dynamic facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-network init dynamic\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_dynamic_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+
+	return LTT_FACILITY_SYMBOL;
+}
+
+static void __exit facility_exit(void)
+{
+	int err;
+
+	err = ltt_facility_dynamic_unregister(LTT_FACILITY_SYMBOL);
+	if(err != 0)
+		printk(KERN_ERR "LTT : Error in unregistering facility.\n");
+
+}
+
+module_init(facility_init)
+module_exit(facility_exit)
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Facility");
+
+#endif //MODULE
+
+#endif //CONFIG_LTT
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-network.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-network.h
--- linux-2.6.14.5/ltt/ltt-facility-loader-network.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-network.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+#ifndef _LTT_FACILITY_LOADER_NETWORK_H_
+#define _LTT_FACILITY_LOADER_NETWORK_H_
+
+#ifdef CONFIG_LTT
+
+#include <linux/ltt-facilities.h>
+#include <linux/ltt/ltt-facility-id-network.h>
+
+ltt_facility_t	ltt_facility_network;
+ltt_facility_t	ltt_facility_network_8B91EC6C;
+
+#define LTT_FACILITY_SYMBOL							ltt_facility_network
+#define LTT_FACILITY_CHECKSUM_SYMBOL		ltt_facility_network_8B91EC6C
+#define LTT_FACILITY_CHECKSUM						0x8B91EC6C
+#define LTT_FACILITY_NAME								"network"
+#define LTT_FACILITY_NUM_EVENTS					facility_network_num_events
+
+#endif //CONFIG_LTT
+
+#endif //_LTT_FACILITY_LOADER_NETWORK_H_
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-process.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-process.c
--- linux-2.6.14.5/ltt/ltt-facility-loader-process.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-process.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,86 @@
+/*
+ * ltt-facility-loader-process.c
+ *
+ * (C) Copyright  2005 - 
+ *          Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the LTT facility loader.
+ *
+ */
+
+
+#include <linux/ltt-facilities.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/config.h>
+#include "ltt-facility-loader-process.h"
+
+
+#ifdef CONFIG_LTT
+
+EXPORT_SYMBOL(LTT_FACILITY_SYMBOL);
+EXPORT_SYMBOL(LTT_FACILITY_CHECKSUM_SYMBOL);
+
+static const char ltt_facility_name[] = LTT_FACILITY_NAME;
+
+#define SYMBOL_STRING(sym) #sym
+
+static struct ltt_facility facility = {
+	.name = ltt_facility_name,
+	.num_events = LTT_FACILITY_NUM_EVENTS,
+	.checksum = LTT_FACILITY_CHECKSUM,
+	.symbol = SYMBOL_STRING(LTT_FACILITY_SYMBOL),
+};
+
+#ifndef MODULE
+
+/* Built-in facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-process init in kernel\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_builtin_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+	
+	return LTT_FACILITY_SYMBOL;
+}
+__initcall(facility_init);
+
+
+
+#else 
+
+/* Dynamic facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-process init dynamic\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_dynamic_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+
+	return LTT_FACILITY_SYMBOL;
+}
+
+static void __exit facility_exit(void)
+{
+	int err;
+
+	err = ltt_facility_dynamic_unregister(LTT_FACILITY_SYMBOL);
+	if(err != 0)
+		printk(KERN_ERR "LTT : Error in unregistering facility.\n");
+
+}
+
+module_init(facility_init)
+module_exit(facility_exit)
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Facility");
+
+#endif //MODULE
+
+#endif //CONFIG_LTT
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-process.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-process.h
--- linux-2.6.14.5/ltt/ltt-facility-loader-process.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-process.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+#ifndef _LTT_FACILITY_LOADER_PROCESS_H_
+#define _LTT_FACILITY_LOADER_PROCESS_H_
+
+#ifdef CONFIG_LTT
+
+#include <linux/ltt-facilities.h>
+#include <linux/ltt/ltt-facility-id-process.h>
+
+ltt_facility_t	ltt_facility_process;
+ltt_facility_t	ltt_facility_process_F7697017;
+
+#define LTT_FACILITY_SYMBOL							ltt_facility_process
+#define LTT_FACILITY_CHECKSUM_SYMBOL		ltt_facility_process_F7697017
+#define LTT_FACILITY_CHECKSUM						0xF7697017
+#define LTT_FACILITY_NAME								"process"
+#define LTT_FACILITY_NUM_EVENTS					facility_process_num_events
+
+#endif //CONFIG_LTT
+
+#endif //_LTT_FACILITY_LOADER_PROCESS_H_
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-socket.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-socket.c
--- linux-2.6.14.5/ltt/ltt-facility-loader-socket.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-socket.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,86 @@
+/*
+ * ltt-facility-loader-socket.c
+ *
+ * (C) Copyright  2005 - 
+ *          Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the LTT facility loader.
+ *
+ */
+
+
+#include <linux/ltt-facilities.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/config.h>
+#include "ltt-facility-loader-socket.h"
+
+
+#ifdef CONFIG_LTT
+
+EXPORT_SYMBOL(LTT_FACILITY_SYMBOL);
+EXPORT_SYMBOL(LTT_FACILITY_CHECKSUM_SYMBOL);
+
+static const char ltt_facility_name[] = LTT_FACILITY_NAME;
+
+#define SYMBOL_STRING(sym) #sym
+
+static struct ltt_facility facility = {
+	.name = ltt_facility_name,
+	.num_events = LTT_FACILITY_NUM_EVENTS,
+	.checksum = LTT_FACILITY_CHECKSUM,
+	.symbol = SYMBOL_STRING(LTT_FACILITY_SYMBOL),
+};
+
+#ifndef MODULE
+
+/* Built-in facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-socket init in kernel\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_builtin_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+	
+	return LTT_FACILITY_SYMBOL;
+}
+__initcall(facility_init);
+
+
+
+#else 
+
+/* Dynamic facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-socket init dynamic\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_dynamic_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+
+	return LTT_FACILITY_SYMBOL;
+}
+
+static void __exit facility_exit(void)
+{
+	int err;
+
+	err = ltt_facility_dynamic_unregister(LTT_FACILITY_SYMBOL);
+	if(err != 0)
+		printk(KERN_ERR "LTT : Error in unregistering facility.\n");
+
+}
+
+module_init(facility_init)
+module_exit(facility_exit)
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Facility");
+
+#endif //MODULE
+
+#endif //CONFIG_LTT
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-socket.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-socket.h
--- linux-2.6.14.5/ltt/ltt-facility-loader-socket.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-socket.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+#ifndef _LTT_FACILITY_LOADER_SOCKET_H_
+#define _LTT_FACILITY_LOADER_SOCKET_H_
+
+#ifdef CONFIG_LTT
+
+#include <linux/ltt-facilities.h>
+#include <linux/ltt/ltt-facility-id-socket.h>
+
+ltt_facility_t	ltt_facility_socket;
+ltt_facility_t	ltt_facility_socket_5E76ED18;
+
+#define LTT_FACILITY_SYMBOL							ltt_facility_socket
+#define LTT_FACILITY_CHECKSUM_SYMBOL		ltt_facility_socket_5E76ED18
+#define LTT_FACILITY_CHECKSUM						0x5E76ED18
+#define LTT_FACILITY_NAME								"socket"
+#define LTT_FACILITY_NUM_EVENTS					facility_socket_num_events
+
+#endif //CONFIG_LTT
+
+#endif //_LTT_FACILITY_LOADER_SOCKET_H_
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-statedump.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-statedump.c
--- linux-2.6.14.5/ltt/ltt-facility-loader-statedump.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-statedump.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,86 @@
+/*
+ * ltt-facility-loader-statedump.c
+ *
+ * (C) Copyright  2005 - 
+ *          Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the LTT facility loader.
+ *
+ */
+
+
+#include <linux/ltt-facilities.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/config.h>
+#include "ltt-facility-loader-statedump.h"
+
+
+#ifdef CONFIG_LTT
+
+EXPORT_SYMBOL(LTT_FACILITY_SYMBOL);
+EXPORT_SYMBOL(LTT_FACILITY_CHECKSUM_SYMBOL);
+
+static const char ltt_facility_name[] = LTT_FACILITY_NAME;
+
+#define SYMBOL_STRING(sym) #sym
+
+static struct ltt_facility facility = {
+	.name = ltt_facility_name,
+	.num_events = LTT_FACILITY_NUM_EVENTS,
+	.checksum = LTT_FACILITY_CHECKSUM,
+	.symbol = SYMBOL_STRING(LTT_FACILITY_SYMBOL),
+};
+
+#ifndef MODULE
+
+/* Built-in facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-statedump init in kernel\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_builtin_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+	
+	return LTT_FACILITY_SYMBOL;
+}
+__initcall(facility_init);
+
+
+
+#else 
+
+/* Dynamic facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-statedump init dynamic\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_dynamic_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+
+	return LTT_FACILITY_SYMBOL;
+}
+
+static void __exit facility_exit(void)
+{
+	int err;
+
+	err = ltt_facility_dynamic_unregister(LTT_FACILITY_SYMBOL);
+	if(err != 0)
+		printk(KERN_ERR "LTT : Error in unregistering facility.\n");
+
+}
+
+module_init(facility_init)
+module_exit(facility_exit)
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Facility");
+
+#endif //MODULE
+
+#endif //CONFIG_LTT
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-statedump.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-statedump.h
--- linux-2.6.14.5/ltt/ltt-facility-loader-statedump.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-statedump.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+#ifndef _LTT_FACILITY_LOADER_STATEDUMP_H_
+#define _LTT_FACILITY_LOADER_STATEDUMP_H_
+
+#ifdef CONFIG_LTT
+
+#include <linux/ltt-facilities.h>
+#include <linux/ltt/ltt-facility-id-statedump.h>
+
+ltt_facility_t	ltt_facility_statedump;
+ltt_facility_t	ltt_facility_statedump_31582B7A;
+
+#define LTT_FACILITY_SYMBOL							ltt_facility_statedump
+#define LTT_FACILITY_CHECKSUM_SYMBOL		ltt_facility_statedump_31582B7A
+#define LTT_FACILITY_CHECKSUM						0x31582B7A
+#define LTT_FACILITY_NAME								"statedump"
+#define LTT_FACILITY_NUM_EVENTS					facility_statedump_num_events
+
+#endif //CONFIG_LTT
+
+#endif //_LTT_FACILITY_LOADER_STATEDUMP_H_
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-timer.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-timer.c
--- linux-2.6.14.5/ltt/ltt-facility-loader-timer.c	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-timer.c	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,86 @@
+/*
+ * ltt-facility-loader-timer.c
+ *
+ * (C) Copyright  2005 - 
+ *          Mathieu Desnoyers (mathieu.desnoyers@polymtl.ca)
+ *
+ * Contains the LTT facility loader.
+ *
+ */
+
+
+#include <linux/ltt-facilities.h>
+#include <linux/module.h>
+#include <linux/init.h>
+#include <linux/config.h>
+#include "ltt-facility-loader-timer.h"
+
+
+#ifdef CONFIG_LTT
+
+EXPORT_SYMBOL(LTT_FACILITY_SYMBOL);
+EXPORT_SYMBOL(LTT_FACILITY_CHECKSUM_SYMBOL);
+
+static const char ltt_facility_name[] = LTT_FACILITY_NAME;
+
+#define SYMBOL_STRING(sym) #sym
+
+static struct ltt_facility facility = {
+	.name = ltt_facility_name,
+	.num_events = LTT_FACILITY_NUM_EVENTS,
+	.checksum = LTT_FACILITY_CHECKSUM,
+	.symbol = SYMBOL_STRING(LTT_FACILITY_SYMBOL),
+};
+
+#ifndef MODULE
+
+/* Built-in facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-timer init in kernel\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_builtin_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+	
+	return LTT_FACILITY_SYMBOL;
+}
+__initcall(facility_init);
+
+
+
+#else 
+
+/* Dynamic facility. */
+
+static int __init facility_init(void)
+{
+	printk(KERN_INFO "LTT : ltt-facility-timer init dynamic\n");
+
+	LTT_FACILITY_SYMBOL = ltt_facility_dynamic_register(&facility);
+	LTT_FACILITY_CHECKSUM_SYMBOL = LTT_FACILITY_SYMBOL;
+
+	return LTT_FACILITY_SYMBOL;
+}
+
+static void __exit facility_exit(void)
+{
+	int err;
+
+	err = ltt_facility_dynamic_unregister(LTT_FACILITY_SYMBOL);
+	if(err != 0)
+		printk(KERN_ERR "LTT : Error in unregistering facility.\n");
+
+}
+
+module_init(facility_init)
+module_exit(facility_exit)
+
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Mathieu Desnoyers");
+MODULE_DESCRIPTION("Linux Trace Toolkit Facility");
+
+#endif //MODULE
+
+#endif //CONFIG_LTT
diff -uNrp linux-2.6.14.5/ltt/ltt-facility-loader-timer.h linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-timer.h
--- linux-2.6.14.5/ltt/ltt-facility-loader-timer.h	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/ltt-facility-loader-timer.h	2006-01-22 13:01:14.000000000 +0100
@@ -0,0 +1,20 @@
+#ifndef _LTT_FACILITY_LOADER_TIMER_H_
+#define _LTT_FACILITY_LOADER_TIMER_H_
+
+#ifdef CONFIG_LTT
+
+#include <linux/ltt-facilities.h>
+#include <linux/ltt/ltt-facility-id-timer.h>
+
+ltt_facility_t	ltt_facility_timer;
+ltt_facility_t	ltt_facility_timer_5EACEACA;
+
+#define LTT_FACILITY_SYMBOL							ltt_facility_timer
+#define LTT_FACILITY_CHECKSUM_SYMBOL		ltt_facility_timer_5EACEACA
+#define LTT_FACILITY_CHECKSUM						0x5EACEACA
+#define LTT_FACILITY_NAME								"timer"
+#define LTT_FACILITY_NUM_EVENTS					facility_timer_num_events
+
+#endif //CONFIG_LTT
+
+#endif //_LTT_FACILITY_LOADER_TIMER_H_
diff -uNrp linux-2.6.14.5/ltt/Makefile linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/Makefile
--- linux-2.6.14.5/ltt/Makefile	1970-01-01 01:00:00.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/ltt/Makefile	2006-01-22 13:01:54.000000000 +0100
@@ -0,0 +1,15 @@
+#
+# Makefile for the linux kernel.
+#
+#
+obj-$(CONFIG_LTT) += ltt-facility-loader-core.o
+obj-$(CONFIG_LTT) += ltt-facility-loader-fs.o
+obj-$(CONFIG_LTT) += ltt-facility-loader-ipc.o
+obj-$(CONFIG_LTT) += ltt-facility-loader-kernel.o
+obj-$(CONFIG_LTT) += ltt-facility-loader-memory.o
+obj-$(CONFIG_LTT) += ltt-facility-loader-network.o
+obj-$(CONFIG_LTT) += ltt-facility-loader-process.o
+obj-$(CONFIG_LTT) += ltt-facility-loader-socket.o
+obj-$(CONFIG_LTT) += ltt-facility-loader-timer.o
+obj-$(CONFIG_LTT) += ltt-facility-loader-statedump.o
+
diff -uNrp linux-2.6.14.5/MAINTAINERS linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/MAINTAINERS
--- linux-2.6.14.5/MAINTAINERS	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/MAINTAINERS	2006-01-22 13:01:14.000000000 +0100
@@ -1538,6 +1538,16 @@ L:	linux-security-module@wirex.com
 W:	http://lsm.immunix.org
 S:	Supported
 
+LINUX TRACE TOOLKIT
+P:	Karim Yaghmour
+M:	karim@opersys.com
+P:	Mathieu Desnoyers
+M:	mathieu.desnoyers@polymtl.ca
+W:	http://www.opersys.com/LTT
+W:	http://ltt.polymtl.ca
+L:	ltt-dev@listserv.shafik.org
+S:	Maintained
+
 LM83 HARDWARE MONITOR DRIVER
 P:	Jean Delvare
 M:	khali@linux-fr.org
diff -uNrp linux-2.6.14.5/Makefile linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/Makefile
--- linux-2.6.14.5/Makefile	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/Makefile	2006-01-22 13:01:14.000000000 +0100
@@ -582,7 +582,7 @@ export MODLIB
 
 
 ifeq ($(KBUILD_EXTMOD),)
-core-y		+= kernel/ mm/ fs/ ipc/ security/ crypto/
+core-y		+= kernel/ mm/ fs/ ipc/ security/ crypto/ ltt/
 
 vmlinux-dirs	:= $(patsubst %/,%,$(filter %/, $(init-y) $(init-m) \
 		     $(core-y) $(core-m) $(drivers-y) $(drivers-m) \
diff -uNrp linux-2.6.14.5/mm/filemap.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/mm/filemap.c
--- linux-2.6.14.5/mm/filemap.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/mm/filemap.c	2006-01-22 13:01:14.000000000 +0100
@@ -9,6 +9,7 @@
  * most "normal" filesystems (but you don't /have/ to use this:
  * the NFS filesystem used to do this differently, for example)
  */
+#include <linux/ltt/ltt-facility-memory.h>
 #include <linux/config.h>
 #include <linux/module.h>
 #include <linux/slab.h>
@@ -435,9 +436,13 @@ void fastcall wait_on_page_bit(struct pa
 {
 	DEFINE_WAIT_BIT(wait, &page->flags, bit_nr);
 
+	trace_memory_page_wait_start(page_address(page));
+
 	if (test_bit(bit_nr, &page->flags))
 		__wait_on_bit(page_waitqueue(page), &wait, sync_page,
 							TASK_UNINTERRUPTIBLE);
+
+	trace_memory_page_wait_end(page_address(page));
 }
 EXPORT_SYMBOL(wait_on_page_bit);
 
diff -uNrp linux-2.6.14.5/mm/memory.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/mm/memory.c
--- linux-2.6.14.5/mm/memory.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/mm/memory.c	2006-01-22 13:01:14.000000000 +0100
@@ -38,6 +38,7 @@
  * Aug/Sep 2004 Changed to four level page tables (Andi Kleen)
  */
 
+#include <linux/ltt/ltt-facility-memory.h>
 #include <linux/kernel_stat.h>
 #include <linux/mm.h>
 #include <linux/hugetlb.h>
@@ -49,6 +50,8 @@
 #include <linux/module.h>
 #include <linux/init.h>
 
+#include <linux/module.h>
+
 #include <asm/pgalloc.h>
 #include <asm/uaccess.h>
 #include <asm/tlb.h>
@@ -1670,6 +1673,7 @@ static int do_swap_page(struct mm_struct
 	spin_unlock(&mm->page_table_lock);
 	page = lookup_swap_cache(entry);
 	if (!page) {
+		trace_memory_swap_in((void*)address);
  		swapin_readahead(entry, address, vma);
  		page = read_swap_cache_async(entry, vma, address);
 		if (!page) {
diff -uNrp linux-2.6.14.5/mm/page_alloc.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/mm/page_alloc.c
--- linux-2.6.14.5/mm/page_alloc.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/mm/page_alloc.c	2006-01-22 13:01:14.000000000 +0100
@@ -14,6 +14,7 @@
  *          (lots of bits borrowed from Ingo Molnar & Andrew Morton)
  */
 
+#include <linux/ltt/ltt-facility-memory.h>
 #include <linux/config.h>
 #include <linux/stddef.h>
 #include <linux/mm.h>
@@ -371,6 +372,8 @@ void __free_pages_ok(struct page *page, 
 	LIST_HEAD(list);
 	int i;
 
+	trace_memory_page_free(order, page_address(page));
+
 	arch_free_page(page, order);
 
 	mod_page_state(pgfree, 1 << order);
@@ -983,6 +986,7 @@ fastcall unsigned long __get_free_pages(
 	page = alloc_pages(gfp_mask, order);
 	if (!page)
 		return 0;
+	trace_memory_page_alloc(order, page_address(page));
 	return (unsigned long) page_address(page);
 }
 
diff -uNrp linux-2.6.14.5/mm/page_io.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/mm/page_io.c
--- linux-2.6.14.5/mm/page_io.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/mm/page_io.c	2006-01-22 13:01:14.000000000 +0100
@@ -10,6 +10,7 @@
  *  Always use brw_page, life becomes simpler. 12 May 1998 Eric Biederman
  */
 
+#include <linux/ltt/ltt-facility-memory.h>
 #include <linux/mm.h>
 #include <linux/kernel_stat.h>
 #include <linux/pagemap.h>
@@ -102,6 +103,7 @@ int swap_writepage(struct page *page, st
 		rw |= (1 << BIO_RW_SYNC);
 	inc_page_state(pswpout);
 	set_page_writeback(page);
+	trace_memory_swap_out(page_address(page));
 	unlock_page(page);
 	submit_bio(rw, bio);
 out:
diff -uNrp linux-2.6.14.5/mm/vmalloc.c linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/mm/vmalloc.c
--- linux-2.6.14.5/mm/vmalloc.c	2005-12-27 01:26:33.000000000 +0100
+++ linux-2.6.14.5-ipipe-1.1-lttng-0.5-v3/mm/vmalloc.c	2006-01-22 13:01:14.000000000 +0100
@@ -18,6 +18,7 @@
 
 #include <asm/uaccess.h>
 #include <asm/tlbflush.h>
+#include <asm/pgalloc.h>
 
 
 DEFINE_RWLOCK(vmlist_lock);
@@ -148,10 +149,14 @@ int map_vm_area(struct vm_struct *area, 
 	pgd = pgd_offset_k(addr);
 	spin_lock(&init_mm.page_table_lock);
 	do {
+		pgd_t oldpgd;
+		memcpy(&oldpgd,pgd,sizeof(pgd_t));
 		next = pgd_addr_end(addr, end);
 		err = vmap_pud_range(pgd, addr, next, prot, pages);
 		if (err)
 			break;
+		if (pgd_val(oldpgd) != pgd_val(*pgd))
+			set_pgdir(addr, *pgd);
 	} while (pgd++, addr = next, addr != end);
 	spin_unlock(&init_mm.page_table_lock);
 	flush_cache_vmap((unsigned long) area->addr, end);
